#include <julius/julius.h>
//#include <sys/ipc.h>
//#include <sys/shm.h>
//#include <julius/shm.h>

char *
shm_create(size_t shmem_size, int *shm_id)
{
  char *shm_adr;

  if ((*shm_id = shmget(IPC_PRIVATE, shmem_size, 0660 | IPC_CREAT )) < 0) {
    jlog("Error: shm_create: failed to allocate %zu bytes err=%d\n", shmem_size, errno);
    jlog("EACCES=%d, EEXIST=%d, EINVAL=%d, ENFILE=%d, ENOENT=%d, ENOMEM=%d, ENOSPC=%d, EPERM=%d\n", EACCES, EEXIST, EINVAL, ENFILE, ENOENT, ENOMEM, ENOSPC, EPERM);
    return (char *)NULL;
  }
  //jlog("shm_create: shm_id = %d\n", *shm_id);

  shm_adr = (char *)shmat(*shm_id, NULL, 0);

  return shm_adr;
}

// #1369
void
shm_delete_()
{
  GRAMHOOK *gram_hook;

  for(gram_hook=top_gram_hook; gram_hook != NULL; gram_hook=gram_hook->next) {
    //jlog("shm_delete: shm_id = %d\n", gram_hook->shm_id);
    shmctl(gram_hook->shm_id, IPC_RMID, NULL);
  }
  //jlog("shm_delete: shm_id = %d\n", shm_pause_command_flg->shm_id);
  shmctl(shm_pause_command_flg->shm_id, IPC_RMID, NULL);
}
